#ifndef __VM__H
#define __VM__H

/*
 * Copyright (c) 2010, Shane Adams
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the author nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#define ALU 0x80
#define PLUS 0x0
#define MIN  0x1
#define MUL  0x2
#define DIV  0x3
#define MOD  0x4
#define LT   0x5
#define GT   0x6
#define EQ   0x7

#define MEM 0x40
#define SET  0x0
#define GET  0x1
#define IMM  0x2
#define CP   0x3  // Code pointer

#define JMP    0x20
#define JTHEN   0x1  // Jump for IF/THEN/ELSE
#define JELSE   0x2
#define LN      0x3  // Marks a line numbers not a jump, a destination
#define RETURN  0x4  // Return
#define GOTO    0x5  // Goto 
#define GOSUB   0x6  // Gosub
#define NEXT    0x7  // Jump for NEXT
#define END     0x8  // END

void exec();

#endif
